/*
 *  ofxiPhoneImagePicker.h
 *  iPhone UIImagePicker Example
 *
 *  Created by Zach Gage on 3/1/09.
 *  Copyright 2009 stfj. All rights reserved.
 *
 */

#import <UIKit/UIKit.h>
#import <OpenGLES/ES1/gl.h>
#import "ofMain.h"

#define OFX_IMG_PICKER_UP 1
#define OFX_IMG_PICKER_DOWN 2
#define OFX_IMG_PICKER_LEFT 3
#define OFX_IMG_PICKER_RIGHT 4

/*
class canLoadPixels
	{
	public:
		virtual void loadPixels() = 0;
	};
*/

class ofxiPhoneImagePicker;


@interface ofxiPhoneImagePickerDelegate : NSObject <UINavigationControllerDelegate, UIImagePickerControllerDelegate>
{
	UIImagePickerController*			_imagePicker;
	UIImage*							_image;
	bool								cameraIsAvailable;
	bool								photoLibraryIsAvailable;
	bool								savedPhotosIsAvailable;
	
	ofxiPhoneImagePicker *						cppPixelLoader;
}

- (id) initWithPicker:(ofxiPhoneImagePicker *) _picker;
- (void) imagePickerController:(UIImagePickerController *)picker didFinishPickingImage:(UIImage *)image editingInfo:(NSDictionary *)editingInfo;
- (void) imagePickerControllerDidCancel:(UIImagePickerController *)picker;
- (CGImageRef) getCGImage;

- (int) getImageOrientation;

- (bool) openLibrary;
- (bool) openCamera;
- (bool) openSavedPhotos;

- (bool) isCameraAvailable;
- (bool) isPhotoLibraryAvailable;
- (bool) isSavedPhotosAvailable;
- (bool) wasNewImagePicked;

- (void) saveImageToPhotoAlbum;

- (UIImage *) getUIImage;


@end


class ofxiPhoneImagePicker /*: public canLoadPixels*/ // MEMO
	{
		
	public:
		
		ofxiPhoneImagePicker();
		~ofxiPhoneImagePicker();
		
		bool openCamera(); //right now this just gives you access to the cameara
		bool openLibrary();
		bool openSavedPhotos();
		
		bool cameraIsAvailable; //variables to see if specific functions are available for a specific device.
		bool photoLibraryIsAvailable;
		bool savedPhotosIsAvailable;
		
		void setMaxDimension(int _maxDimension); //images that you take with the camera will be too big to properly get into an ofImage (im not sure why). It's good to set a maximum dimension for the images under 1000
		int getOrientation();
		
		void saveImage(); //this doesn't quite work right now and i'm not sure why.
		
		void loadPixels(); //never call this. this is called by the obj-c class.
		bool imageUpdated; //when a new image is loaded in, this is set to true
		bool imageCancelled;	// MEMO: when the picker is cancelled this is set to true
		
		int width;
		int height;
		int type;
		int glType;
		int texType;
		int bpp;
		
		int maxDimension;
		
		unsigned char * pixels;
		
	protected:
		
		ofxiPhoneImagePickerDelegate *	imagePicker;
	};
